pipeline {
   agent any

    environment {
        PORT="80"
        IMAGE_TAG="market-server"
        CONTAINER_NAME="market-server-app"
        DB_URL=credentials('jdbc:sqlserver://project1-gray.database.windows.net:1433;databaseName=project1')
        DB_USER=credentials('dgray@project1-gray')
        DB_PASS=credentials('Deonna77')
    }

   stages {
      stage('checkout'){
          steps {
               git branch: 'master', url: 'https://gitlab.com/210301-java-azure/desjohnna_gray/project1.git'
           }
      }
      stage('clean') {
         steps {
            sh 'sh gradlew clean'
         }
      }
      stage('package') {
         steps {
            sh 'sh gradlew finalJar'
         }
      }
      stage('remove previous image if exists') {
            steps {
                sh 'docker rmi -f ${IMAGE_TAG} || true'
            }
        }

       stage('create image') {
            steps {
                sh 'docker build -t ${IMAGE_TAG} -f Dockerfile .'
            }
        }
        stage('remove previous container if exists') {
            steps {
                sh 'docker stop ${CONTAINER_NAME} || true'
            }
        }
        stage('create container') {
            steps {
                sh 'docker run -d --rm -p ${PORT}:${PORT} -e DB_USER -e DB_PASS -e DB_URL --name ${CONTAINER_NAME} ${IMAGE_TAG}'
            }
        }
    }
}
